鼠标悬停监视——待调试

发布于:2025-03-31 ⋅ 阅读:(28) ⋅ 点赞:(0)

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.EditorInput;

using Autodesk.AutoCAD.Runtime;

using System;

using System.Text;

 

public class AttributeHoverMonitor

{

    private static Editor _ed;

    private static object _lastHoveredId = null;

 

    [CommandMethod("StartHoverMonitor")]

    public static void StartHoverMonitor()

    {

        _ed = Application.DocumentManager.MdiActiveDocument.Editor;

        _ed.PointMonitor += OnPointMonitor;

        _ed.WriteMessage("\n属性悬停监视已启用");

    }

 

    [CommandMethod("StopHoverMonitor")]

    public static void StopHoverMonitor()

    {

        _ed.PointMonitor -= OnPointMonitor;

        _ed.WriteMessage("\n属性悬停监视已禁用");

    }

 

    private static void OnPointMonitor(object sender, PointMonitorEventArgs e)

    {

        try

        {

            using (var tr = _ed.Document.TransactionManager.StartOpenCloseTransaction())

            {

                var objId = e.Context.GetPickedEntities()?.FirstOrDefault().ObjectId;

                if (objId == null || !objId.IsValid) return;

 

                // 性能优化:仅当悬停新对象时处理

                if (_lastHoveredId != null && _lastHoveredId.Equals(objId)) return;

                _lastHoveredId = objId;

 

                var entity = tr.GetObject(objId, OpenMode.ForRead) as Entity;

                if (entity is BlockReference br)

                {

                    var tooltip = GetAttributeTooltip(br, tr);

                    if (!string.IsNullOrEmpty(tooltip))

                    {

                        // 显示自定义工具提示

                        e.Context.SetToolTip(tooltip, new Point2d(e.Context.RawPoint.X + 10, e.Context.RawPoint.Y));

                    }

                }

                tr.Commit();

            }

        }

        catch { /* 错误处理 */ }

    }

 

    private static string GetAttributeTooltip(BlockReference br, Transaction tr)

    {

        var sb = new StringBuilder();

        sb.AppendLine($"块名称:{br.GetBlockName(tr)}");

        sb.AppendLine($"位置:{br.Position.ToString()}");

 

        foreach (ObjectId attId in br.AttributeCollection)

        {

            if (!attId.IsValid) continue;

            var attRef = tr.GetObject(attId, OpenMode.ForRead) as AttributeReference;

            sb.AppendLine($"{attRef?.Tag}:{attRef?.TextString}");

        }

 

        return sb.ToString();

    }

}

 

// BlockReference扩展方法

public static class BlockExtensions

{

    public static string GetBlockName(this BlockReference br, Transaction tr)

    {

        return ((BlockTableRecord)tr.GetObject(br.BlockTableRecord, OpenMode.ForRead)).Name;

    }

}

// 在原有代码基础上添加以下功能

private static void OnPointMonitor(object sender, PointMonitorEventArgs e)

{

    // ...原有代码...

 

    // 添加高亮显示

    if (entity is BlockReference)

    {

        e.Context.HighlightEntities(new ObjectId[] { objId });

    }

 

    // 添加动态预览窗口

    var previewPos = new Point3d(e.Context.RawPoint.X + 20, e.Context.RawPoint.Y - 50, 0);

    e.Context.DrawText(previewPos, tooltip, 12, TextAlignment.Left);

}